import { ModelFactory } from "./model/ModelFactory";
import { Net } from "./net/Net";
import { NotificationCenter } from "./nc/NotificationCenter";
import { DBManager } from "./db/DBManager";
export declare class Plugin {
    private constructor();
    static register(name: string): void;
    static getBy(name: string): Plugin;
    getName(): string;
    nc(): NotificationCenter;
    mf(): ModelFactory;
    dbManager(): DBManager;
    setDBManager(dbm: DBManager): void;
    net(baseUrl: string): Net;
    getMainNet(): Net;
    setMainNet(net: Net): void;
    private static allPlugins;
    private readonly name_;
    private readonly nc_;
    private readonly mf_;
    private nets_;
    private mainNet_;
    private dbManager_;
}
