import { DB } from "./DB";
import { Plugin } from "../Plugin";
import { Storage } from "./Storage";
export declare abstract class DBManager {
    getShareDBAtSessionStorage(): DB;
    getShareDBAtLocalStorage(): DB;
    getSelfDB(): Promise<DB>;
    getPlugin(): Plugin;
    private createSelfDB;
    private getDBName;
    /**
     *
     * @param plugin
     *
     * 初始化时，不要初始化SelfDB, 因为 self 依赖me, 而按照整个框架，me 依赖于shareDB ,
     * 此时，任何DB都还不能确定创建好，也不能确定初始化的顺序，所以不能在这里初始化selfDB
     */
    constructor(plugin: Plugin);
    protected abstract newSessionStorage(): Storage;
    protected abstract newLocalStorage(): Storage;
    private shareAtLocal_;
    private shareAtSession_;
    private selfDB_;
    static readonly shareName = "share";
    private readonly plugin_;
}
