import { Model, ModelEvent } from "./Model";
import { MergeStrategy } from "./merge/MergeStrategy";
export declare class ListModelEvent extends ModelEvent {
    listKey: string;
    constructor(listKey: string);
}
export declare class ListModel extends Model {
    get(key: string): Promise<string[] | null>;
    set(key: string, list: string[]): Promise<void>;
    add(key: string, value: string): Promise<void>;
    remove(key: string, value: string): Promise<void>;
    setNoPost(key: string, list: string[]): Promise<void>;
    setWithStrategy(key: string, list: string[], merge: MergeStrategy, post: boolean): Promise<void>;
    setWithStrategyNotSafe(key: string, list: string[], merge: MergeStrategy, post: boolean): Promise<void>;
    init(): Promise<void>;
    private list_;
    private table_;
    private runner_;
}
