import { Plugin } from "../Plugin";
import { HttpBuilder } from "./http/HttpBuilder";
/**
 * 401 表示net层不通，连通net层的方法常常是 login
 */
export declare class Net {
    constructor(plugin: Plugin, baseUrl: string);
    process401(): Promise<void>;
    set401Delegate(net401Delegate: ((net: Net) => Promise<void>)): void;
    set401(): void;
    is401(): boolean;
    clear401(): void;
    getBaseUrl(): string;
    setHttpBuilderCreator(creator: (baseUrl: string) => HttpBuilder): void;
    getHttpBuilder(): HttpBuilder;
    setToken(token: string): Promise<void>;
    getToken(): Promise<string>;
    clearToken(): Promise<void>;
    setToMainNet(): this;
    isMainNet(): boolean;
    getPlugin(): Plugin;
    private has401_;
    private creator_;
    private readonly plugin_;
    private readonly baseUrl_;
    private mainNet_;
    private net401Delegate_;
}
