import { Http } from "./Http";
export declare type Method = 'get' | 'GET' | 'delete' | 'DELETE' | 'head' | 'HEAD' | 'options' | 'OPTIONS' | 'post' | 'POST' | 'put' | 'PUT' | 'patch' | 'PATCH' | 'purge' | 'PURGE' | 'link' | 'LINK' | 'unlink' | 'UNLINK';
export declare abstract class HttpBuilder {
    abstract build(): Http;
    protected baseUrl_: string;
    protected uri_: string;
    protected headers_: Map<string, string>;
    protected content_: string;
    protected method_: Method;
    setContent(content: string): this;
    content(): string;
    setMethod(method: Method): this;
    method(): Method;
    setBaseUrl(url: string): this;
    baseUrl(): string;
    setUri(uri: string): this;
    uri(): string;
    setHeaders(headers: Map<string, string>): this;
    addHeader(key: string, val: string): this;
    headers(): Map<string, string>;
    getUrl(): string;
}
