import { Table } from "./Table";
import { DB } from "./DB";
class NullStorage {
    get(key) {
        throw new Error("get not implement");
    }
    remove(key) {
        throw new Error("remove not implement");
    }
    set(key, value) {
        throw new Error("set not implement");
    }
    getAllKeys(table) {
        throw new Error("getAllKeys not implement");
    }
}
export class NullTable extends Table {
    get(key) {
        throw new Error("get error!---invalid table");
    }
    set(key, value) {
        throw new Error("set error!---invalid table");
    }
    remove(key) {
        throw new Error("remove error!---invalid table");
    }
    constructor() {
        super(new DB(new NullStorage(), ""), "");
    }
}
