var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
export class Table {
    constructor(db, name) {
        this.db_ = db;
        this.name_ = name;
    }
    get(key) {
        return __awaiter(this, void 0, void 0, function* () {
            return (yield this.db_.get(this.name_, key));
        });
    }
    set(key, value, delay = 0) {
        return __awaiter(this, void 0, void 0, function* () {
            return (yield this.db_.set(this.name_, key, value, delay));
        });
    }
    remove(key) {
        return __awaiter(this, void 0, void 0, function* () {
            return (yield this.db_.remove(this.name_, key));
        });
    }
    getAllKeys() {
        return __awaiter(this, void 0, void 0, function* () {
            return (yield this.db_.getAllKeys(this.name_));
        });
    }
}
