var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { Model } from "./Model";
import { Table } from "../db/Table";
import { NullTable } from "../db/NullTable";
export class DeviceModel extends Model {
    constructor() {
        super(...arguments);
        this.table_ = new NullTable();
        this.uuid_ = null;
    }
    getUUID() {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.uuid_ != null) {
                return this.uuid_;
            }
            this.uuid_ = 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
                var r = Math.random() * 16 | 0, v = c == 'x' ? r : (r & 0x3 | 0x8);
                return v.toString(16);
            });
            yield this.table_.set(DeviceModel.UUIDStr, this.uuid_);
            return this.uuid_;
        });
    }
    init() {
        return __awaiter(this, void 0, void 0, function* () {
            this.table_ = new Table(this.getDBM().getShareDBAtLocalStorage(), "Device");
            let [uuid, err] = yield this.table_.get(DeviceModel.UUIDStr);
            if (err === null) {
                this.uuid_ = uuid;
            }
        });
    }
}
DeviceModel.UUIDStr = "UUID";
