var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
import { Model } from "./Model";
import { Table } from "../db/Table";
import { NullTable } from "../db/NullTable";
export class Token extends Model {
    constructor() {
        super(...arguments);
        this.table_ = new NullTable();
        this.tokens_ = new Map();
    }
    get(url) {
        return __awaiter(this, void 0, void 0, function* () {
            let token = this.tokens_.get(url);
            if (token === undefined || token === null) {
                let [t, err] = yield this.table_.get(url);
                if (!err) {
                    token = t;
                    this.tokens_.set(url, t);
                }
                else {
                    token = Token.empty;
                }
            }
            return token;
        });
    }
    set(url, token) {
        return __awaiter(this, void 0, void 0, function* () {
            this.tokens_.set(url, token);
            yield this.table_.set(url, token);
        });
    }
    clear(url) {
        return __awaiter(this, void 0, void 0, function* () {
            this.tokens_.delete(url);
            yield this.table_.remove(url);
        });
    }
    init() {
        return __awaiter(this, void 0, void 0, function* () {
            this.table_ = new Table(yield this.getDBM().getSelfDB(), "Token");
        });
    }
}
Token.empty = "";
