var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
export class DB {
    constructor(storage, name) {
        this.name_ = name;
        this.storage_ = storage;
    }
    get(table, key) {
        return __awaiter(this, void 0, void 0, function* () {
            return (yield this.storage_.get(this.getFullTable(table), key));
        });
    }
    set(table, key, value, delay) {
        return __awaiter(this, void 0, void 0, function* () {
            return (yield this.storage_.set(this.getFullTable(table), key, value, delay));
        });
    }
    remove(table, key) {
        return __awaiter(this, void 0, void 0, function* () {
            return (yield this.storage_.remove(this.getFullTable(table), key));
        });
    }
    getAllKeys(table) {
        return __awaiter(this, void 0, void 0, function* () {
            return (yield this.storage_.getAllKeys(this.getFullTable(table)));
        });
    }
    getFullTable(table) {
        return this.name_ + "." + table;
    }
}
