import {Duration} from "mvx-utils";
import {DB} from "./DB";


export class Table {
  public async get(key:string):Promise<[string, Error|null]> {
    return (await this.db_.get(this.name_, key));
  }

  public async set(key:string, value:string, delay:Duration = 0):Promise<Error|null> {
    return (await this.db_.set(this.name_, key, value, delay));
  }

  public async remove(key:string):Promise<Error|null> {
    return (await this.db_.remove(this.name_, key));
  }

  public async getAllKeys():Promise<string[]> {
    return (await this.db_.getAllKeys(this.name_))
  }

  public constructor(db:DB, name:string) {
    this.db_ = db;
    this.name_ = name;
  }

  private readonly name_:string;
  private db_:DB;
}