var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
export class SequentiallyRun {
    constructor() {
        this.waitingQueue_ = [];
        this.isRunning = false;
    }
    Push(task) {
        this.waitingQueue_.push(task);
        this.run().then();
    }
    run() {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.waitingQueue_.length == 0 || this.isRunning) {
                return;
            }
            this.isRunning = true;
            let task = this.waitingQueue_.shift();
            yield task();
            this.isRunning = false;
            // 不需要等待下一个run执行结束
            this.run().then();
        });
    }
}
